Name:           asco
Summary:        A SPICE Circuit Optimizer
Version:        0.4.11
Release:        1%{dist}
License:        GPLv2+
Url:            http://asco.sourceforge.net/
Source0:        http://downloads.sourceforge.net/asco/ASCO-%{version}.tar.gz
# https://sourceforge.net/p/asco/discussion/485420/thread/61b8ecf5/
Patch1:         %{name}-Fix-compilation-issues.patch
# https://sourceforge.net/p/asco/discussion/485420/thread/bd767cf1/
Patch2:         %{name}-Add-missing-declaration-of-DetectsTransistorColumns.patch
# Do not alter CFLAGS, CXXFLAGS and LDFLAGS
Patch3:         %{name}-do-not-alter-cflags.patch
# Do not require c++ compiler
Patch4:         %{name}-remove-cpp-dependency.patch
# Removes duplicates in variable definitions.
Patch5:         %{name}-Remove-multiple-definitions-linking-errors.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc

Requires:       ngspice


%description
ASCO project aims to bring circuit optimization capabilities to existing SPICE
simulators using a high-performance parallel differential evolution (DE)
optimization algorithm. Currently out-of-the-box support for Eldo (TM),
HSPICE (R), LTspice (TM), Spectre (R), Qucs and ngspice exist.


%prep
%setup -n ASCO-%{version}

tar -zxf Autotools.tar.gz


# Remove duplicated files
# Upstream reference:
#     https://sourceforge.net/p/asco/discussion/485420/thread/1c38a18a/
pushd tools/alter
ln -sf ../../auxfunc_alter.c
ln -sf ../../auxfunc_alter.h
popd

pushd tools/auxfunc
ln -sf ../../auxfunc.c
ln -sf ../../auxfunc.h
popd

pushd tools/log
ln -sf ../../auxfunc.c
ln -sf ../../auxfunc.h
popd

pushd tools/monte
ln -sf ../../auxfunc.h
ln -sf ../../auxfunc_monte.c
ln -sf ../../auxfunc_monte.h
popd

pushd tools/postp
ln -sf ../../auxfunc.h
ln -sf ../../auxfunc_measurefromlis.c
ln -sf ../../auxfunc_measurefromlis.h
popd

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

autoreconf -fi


%build
%configure
make %{?_smp_mflags}


%install
%make_install
# Extract examples for ngspice and Qucs
mkdir -p exported/examples
cp -a examples/{ngspice,Qucs} exported/examples/
find exported -name 'Makefile*' | xargs rm -f


%files
%license LICENSE
%doc ChangeLog README doc/ASCO.pdf exported/examples
%{_bindir}/asco
%{_bindir}/asco-test
# According to: http://ngspice.sourceforge.net/docs/ngspice26-manual.pdf
# 23.5 ngspice optimizer using ASCO
# "Several stand alone tools are provided, but not tested yet."
# Thus we will no include them.
%exclude %{_bindir}/alter
%exclude %{_bindir}/log
%exclude %{_bindir}/monte
%exclude %{_bindir}/postp
%exclude %{_bindir}/rosen


%changelog
* Fri Apr 14 2023 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.4.11-1
- Update to latest available version
- Removes duplicates in variable definitions.

* Tue Aug 21 2018 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.4.10-4
- Do not require c++ compiler.

* Mon Aug 20 2018 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.4.10-3
- Re-enable generation of debug-info.

* Mon Mar 12 2018 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.4.10-2
- fix BR dependencies (git),
- disable debug-info.

* Mon May 08 2017 Damian Wrobel <dwrobel@ertelnet.rybnik.pl> - 0.4.10-1
- Initial RPM release.
